#ifndef splugin_h_
# define splugin_h_

/* includes */
#include <mysql_priv.h>
#include <string.h>
#include <stdio.h>
#include <mysql/plugin.h>
#include <sigar.h>

/* Data types definitions for asprintf && store functions */
#define SP_SIGNED              false
#define SP_UNSIGNED            true
#define SP_UINT32              "%u"
#define SP_DOUBLE              "%.2f"
#define SP_RETURN_TYPE         int

# define SP_UID_UNSIGNED       true
# define SP_GID_UNSIGNED       true

#ifdef WIN32
# define SP_PID_UNSIGNED       true
#else
# define SP_PID_UNSIGNED       false
#endif

#ifdef SIGAR_64BIT
# define SP_UINT64             "%lu"
#else
# define SP_UINT64             "%Lu"
#endif

/* Table field length definitions */
#define SP_ANY_INT32_LENGTH    10
#define SP_ANY_INT64_LENGTH    20
#define SP_INET_ADDR_LENGTH    SIGAR_INET6_ADDRSTRLEN
#define SP_MAC_ADDR_LENGTH     17

#ifdef WIN32
# define SP_PID_LENGTH         SP_ANY_INT64_LENGTH
# define SP_UID_LENGTH         SP_ANY_INT64_LENGTH
# define SP_GID_LENGTH         SP_ANY_INT64_LENGTH
# define ID_FIELD_TYPE         MYSQL_TYPE_LONGLONG
#else
# define SP_PID_LENGTH         SP_ANY_INT32_LENGTH
# define SP_UID_LENGTH         SP_ANY_INT32_LENGTH
# define SP_GID_LENGTH         SP_ANY_INT32_LENGTH
# define ID_FIELD_TYPE         MYSQL_TYPE_LONG
#endif

/* Plugin structure definitions */

#define SP_MAJOR_VERSION       0x00000000
#define SP_MINOR_VERSION       0x00000005
#define SP_AUTHOR              "Muslimas Chochlovas for MySQL AB"

/* small hacks for inet address convert function */
#define SIGAR_AF_UNSPEC  0
#define SIGAR_AF_INET    1
#define SIGAR_AF_INET6   2
#define SIGAR_AF_LINK    3
 
/* Global function definitions */

int schema_table_store_record(THD *thd, TABLE *table);

#endif
